/* $Revision Header * Header built automatically - do not edit! *************
 *
 *	(C) Copyright 1990 by Olaf 'Olsen' Barthel & MXM
 *
 *	Name .....: TerminalPanel.c
 *	Created ..: Monday 21-Jan-91 20:12
 *	Revision .: 0
 *
 *	Date            Author          Comment
 *	=========       ========        ====================
 *	21-Jan-91       Olsen           Created this file!
 *
 * $Revision Header ********************************************************/

#include "TermGlobal.h"

enum	{	GAD_FILTER,GAD_DESTRBS,GAD_AUDBEL,GAD_VISBEL,GAD_FORCE,GAD_DISABLE,
		GAD_CR,GAD_LF,GAD_COLOUR,GAD_EMULATION,GAD_FONT,GAD_USE,GAD_CANCEL };

#define WIDTH	303
#define HEIGHT	165

STATIC STRPTR CRType[4] =
{
	(STRPTR)"Ignore",
	(STRPTR)"As CR",
	(STRPTR)"As CR+LF",
	NULL
};

STATIC STRPTR LFType[4] =
{
	(STRPTR)"Ignore",
	(STRPTR)"As LF",
	(STRPTR)"As LF+CR",
	NULL
};

STATIC STRPTR Emulation[4] =
{
	(STRPTR)"ANSI/VT100",
	(STRPTR)"Atomic",
	(STRPTR)"TTY",
	NULL
};

STATIC STRPTR ColourMode[5] =
{
	(STRPTR)"Amiga",
	(STRPTR)"8 Colours (Blink)",
	(STRPTR)"16 Colours",
	(STRPTR)"Mono",
	NULL
};

STATIC STRPTR Fonts[3] =
{
	(STRPTR)"Topaz",
	(STRPTR)"IBM PC Style",
	NULL
};

	/* TRUE if screen mode limits colour mode. */

STATIC BYTE Limited;

enum	{	MEN_FILTER=1,MEN_DESTRBS,MEN_AUDBEL,MEN_VISBEL,MEN_FORCE,MEN_DISABLE,
		MEN_CR,MEN_LF,MEN_COLOUR,MEN_EMULATIONCTRL,MEN_FONT,MEN_USE,MEN_CANCEL,
		MEN_QUITPANEL };

STATIC struct NewMenu TerminalMenu[] =
{
	{ NM_TITLE, "Project",		 0 , 0, 0, (APTR)0},
	{  NM_ITEM, "Capture Filter",	"F", 0, 0, (APTR)MEN_FILTER},
	{  NM_ITEM, NM_BARLABEL,	 0 , 0, 0, (APTR)0},
	{  NM_ITEM, "Backspace",	"B", 0, 0, (APTR)MEN_DESTRBS},
	{  NM_ITEM, "Audible Bell",	"A", 0, 0, (APTR)MEN_AUDBEL},
	{  NM_ITEM, "Visible Bell",	"V", 0, 0, (APTR)MEN_VISBEL},
	{  NM_ITEM, "Eighty Columns",	"8", 0, 0, (APTR)MEN_FORCE},
	{  NM_ITEM, "Stop Blinking",	"S", 0, 0, (APTR)MEN_DISABLE},
	{  NM_ITEM, NM_BARLABEL,	 0 , 0, 0, (APTR)0},
	{  NM_ITEM, "Send CR",		"R", 0, 0, (APTR)MEN_CR},
	{  NM_ITEM, "Send LF",		"L", 0, 0, (APTR)MEN_LF},
	{  NM_ITEM, NM_BARLABEL,	 0 , 0, 0, (APTR)0},
	{  NM_ITEM, "Colour",		"O", 0, 0, (APTR)MEN_COLOUR},
	{  NM_ITEM, "Emulation",	"E", 0, 0, (APTR)MEN_EMULATIONCTRL},
	{  NM_ITEM, "Font",		"N", 0, 0, (APTR)MEN_FONT},
	{  NM_ITEM, NM_BARLABEL,	 0 , 0, 0, (APTR)0},
	{  NM_ITEM, "Use",		"U", 0, 0, (APTR)MEN_USE},
	{  NM_ITEM, "Cancel",		"C", 0, 0, (APTR)MEN_CANCEL},
	{  NM_ITEM, NM_BARLABEL,	 0 , 0, 0, (APTR)0},
	{  NM_ITEM, "Quit",		"Q", 0, 0, (APTR)MEN_QUITPANEL},
	{ NM_END, 0,			 0 , 0, 0, (APTR)0}
};

STATIC struct Gadget *
CreateAllGadgets(struct Configuration *Config,struct Gadget *GadgetArray[],struct Gadget **GadgetList,APTR VisualInfo,UWORD TopEdge)
{
	struct Gadget		*Gadget;
	struct NewGadget	 NewGadget;
	UWORD			 Counter = 0;

	if(Gadget = CreateContext(GadgetList))
	{
		NewGadget . ng_Width		= 164;
		NewGadget . ng_Height		= 12;
		NewGadget . ng_GadgetText	= "Capture _Filter";
		NewGadget . ng_TextAttr		= &DefaultFont;
		NewGadget . ng_VisualInfo	= VisualInfo;
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_Flags		= NG_HIGHLABEL;
		NewGadget . ng_LeftEdge		= (strlen(NewGadget . ng_GadgetText) + 2 - 1) * 8 + 1;
		NewGadget . ng_TopEdge		= 1 + TopEdge;

		GadgetArray[Counter++] = Gadget = CreateGadget(CHECKBOX_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
			GTCB_Checked,	Config -> CaptureFilter,
		TAG_DONE);

		NewGadget . ng_GadgetText	= "Destructive _BS";
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_TopEdge		= Gadget -> TopEdge + Gadget -> Height + 1;

		GadgetArray[Counter++] = Gadget = CreateGadget(CHECKBOX_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
			GTCB_Checked,	Config -> DestructiveBackspace,
		TAG_DONE);

		NewGadget . ng_GadgetText	= "_Audible Bell";
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_TopEdge		= Gadget -> TopEdge + Gadget -> Height + 1;

		GadgetArray[Counter++] = Gadget = CreateGadget(CHECKBOX_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
			GTCB_Checked,	Config -> AudibleBell,
		TAG_DONE);

		NewGadget . ng_GadgetText	= "_Visible Bell";
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_TopEdge		= Gadget -> TopEdge + Gadget -> Height + 1;

		GadgetArray[Counter++] = Gadget = CreateGadget(CHECKBOX_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
			GTCB_Checked,	Config -> VisibleBell,
		TAG_DONE);

		NewGadget . ng_GadgetText	= "Force _80  24";
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_TopEdge		= Gadget -> TopEdge + Gadget -> Height + 1;

		GadgetArray[Counter++] = Gadget = CreateGadget(CHECKBOX_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
			GTCB_Checked,	Config -> EightyColumns,
		TAG_DONE);

		NewGadget . ng_GadgetText	= "_Stop Blinking";
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_TopEdge		= Gadget -> TopEdge + Gadget -> Height + 1;

		GadgetArray[Counter++] = Gadget = CreateGadget(CHECKBOX_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
			GTCB_Checked,	Config -> DisableBlinking,
		TAG_DONE);

		NewGadget . ng_GadgetText	= "Send C_R";
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_TopEdge		= Gadget -> TopEdge + Gadget -> Height + 2;

		GadgetArray[Counter++] = Gadget = CreateGadget(CYCLE_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
			GTCY_Labels,	CRType,
			GTCY_Active,	Config -> SendCR,
		TAG_DONE);

		NewGadget . ng_GadgetText	= "Send _LF";
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_TopEdge		= Gadget -> TopEdge + Gadget -> Height + 1;

		GadgetArray[Counter++] = Gadget = CreateGadget(CYCLE_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
			GTCY_Labels,	LFType,
			GTCY_Active,	Config -> SendLF,
		TAG_DONE);

		NewGadget . ng_GadgetText	= "Col_our";
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_TopEdge		= Gadget -> TopEdge + Gadget -> Height + 1;

		switch(Config -> DisplayMode & ~MONITOR_ID_MASK)
		{
			case HIRES_KEY:
			case HIRESLACE_KEY:	Limited = FALSE;
						break;

			default:		Limited = TRUE;
						break;
		}

		GadgetArray[Counter++] = Gadget = CreateGadget(CYCLE_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
			GTCY_Labels,	ColourMode,
			GTCY_Active,	Config -> ColourMode,
		TAG_DONE);

		NewGadget . ng_GadgetText	= "_Emulation";
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_TopEdge		= Gadget -> TopEdge + Gadget -> Height + 1;

		GadgetArray[Counter++] = Gadget = CreateGadget(CYCLE_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
			GTCY_Labels,	Emulation,
			GTCY_Active,	Config -> Emulation,
		TAG_DONE);

		NewGadget . ng_GadgetText	= "Fo_nt";
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_TopEdge		= Gadget -> TopEdge + Gadget -> Height + 1;

		if(IBM)
		{
			GadgetArray[Counter++] = Gadget = CreateGadget(CYCLE_KIND,Gadget,&NewGadget,
				GT_Underscore,	'_',
				GTCY_Labels,	Fonts,
				GTCY_Active,	Config -> Font,
			TAG_DONE);
		}
		else
		{
			GadgetArray[Counter++] = Gadget = CreateGadget(CYCLE_KIND,Gadget,&NewGadget,
				GT_Underscore,	'_',
				GTCY_Labels,	Fonts,
				GTCY_Active,	0,
				GA_Disabled,	TRUE,
			TAG_DONE);
		}

		NewGadget . ng_Width		= 52;
		NewGadget . ng_Height		= 12;
		NewGadget . ng_GadgetText	= "_Use";
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_Flags		= 0;
		NewGadget . ng_LeftEdge		= 10;
		NewGadget . ng_TopEdge		= HEIGHT - 3 - NewGadget . ng_Height;

		GadgetArray[Counter++] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
		TAG_DONE);

		NewGadget . ng_GadgetText	= "_Cancel";
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_LeftEdge		= WIDTH - 10 - NewGadget . ng_Width;

		GadgetArray[Counter++] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
		TAG_DONE);
	}

	return(Gadget);
}

BYTE
TerminalPanel(struct Configuration *Config)
{
	struct Window	*PanelWindow;
	struct Menu	*PanelMenu;
	struct Gadget	*GadgetList;
	struct Gadget	*GadgetArray[GAD_CANCEL + 1];
	LONG Value;

	CopyMem(Config,&PrivateConfig,sizeof(struct Configuration));

	if(CreateAllGadgets(Config,&GadgetArray[0],&GadgetList,VisualInfo,Screen -> WBorTop + Screen -> Font -> ta_YSize + 1))
	{
		if(PanelMenu = CreateMenus(TerminalMenu,
			GTMN_FrontPen, 0,
		TAG_DONE))
		{
			if(LayoutMenus(PanelMenu,VisualInfo,
				GTMN_TextAttr,&DefaultFont,
			TAG_DONE))
			{
				if(PanelWindow = OpenWindowTags(NULL,
					WA_Left,	(Screen -> Width - WIDTH) >> 1,
					WA_Top,		(Screen -> Height - HEIGHT) >> 1,
					WA_Width,	WIDTH,
					WA_Height,	HEIGHT,

					WA_Activate,	TRUE,
					WA_DragBar,	TRUE,
					WA_DepthGadget,	TRUE,
					WA_RMBTrap,	TRUE,
					WA_DepthGadget,	TRUE,
					WA_CloseGadget,	TRUE,
					WA_CustomScreen,Screen,

					WA_IDCMP,	IDCMP_CLOSEWINDOW | SLIDERIDCMP | CHECKBOXIDCMP | LISTVIEWIDCMP | IDCMP_MENUPICK,

					WA_Title,	"Terminal Preferences",
				TAG_DONE))
				{
					struct IntuiMessage	*Massage;
					ULONG			 Class,Code;
					struct Gadget		*Gadget;
					BYTE			 Terminated = FALSE;

					PushWindow(PanelWindow);

					AddGList(PanelWindow,GadgetList,(UWORD)-1,(UWORD)-1,NULL);
					RefreshGList(GadgetList,PanelWindow,NULL,(UWORD)-1);
					GT_RefreshWindow(PanelWindow,NULL);

					SetMenuStrip(PanelWindow,PanelMenu);

					PanelWindow -> Flags &= ~WFLG_RMBTRAP;

					while(!Terminated)
					{
						WaitPort(PanelWindow -> UserPort);

						while(!Terminated && (Massage = (struct IntuiMessage *)GT_GetIMsg(PanelWindow -> UserPort)))
						{
							Class	= Massage -> Class;
							Code	= Massage -> Code;
							Gadget	= (struct Gadget *)Massage -> IAddress;

							GT_ReplyIMsg(Massage);

							if(Class == IDCMP_MENUPICK)
							{
								struct MenuItem *MenuItem;

								while(Code != MENUNULL)
								{
									MenuItem = ItemAddress(PanelMenu,Code);

									switch((ULONG)MENU_USERDATA(MenuItem))
									{
										case MEN_QUITPANEL:	Class = IDCMP_CLOSEWINDOW;
													break;

										case MEN_FILTER:	GT_SetGadgetAttrs(GadgetArray[GAD_FILTER],PanelWindow,NULL,
														GTCB_Checked,GadgetArray[GAD_FILTER] -> Flags & GFLG_SELECTED ? FALSE : TRUE,
													TAG_DONE);

													break;

										case MEN_DESTRBS:	GT_SetGadgetAttrs(GadgetArray[GAD_DESTRBS],PanelWindow,NULL,
														GTCB_Checked,GadgetArray[GAD_DESTRBS] -> Flags & GFLG_SELECTED ? FALSE : TRUE,
													TAG_DONE);

													break;

										case MEN_AUDBEL:	GT_SetGadgetAttrs(GadgetArray[GAD_AUDBEL],PanelWindow,NULL,
														GTCB_Checked,GadgetArray[GAD_AUDBEL] -> Flags & GFLG_SELECTED ? FALSE : TRUE,
													TAG_DONE);

													break;

										case MEN_VISBEL:	GT_SetGadgetAttrs(GadgetArray[GAD_VISBEL],PanelWindow,NULL,
														GTCB_Checked,GadgetArray[GAD_VISBEL] -> Flags & GFLG_SELECTED ? FALSE : TRUE,
													TAG_DONE);

													break;

										case MEN_FORCE:		GT_SetGadgetAttrs(GadgetArray[GAD_FORCE],PanelWindow,NULL,
														GTCB_Checked,GadgetArray[GAD_FORCE] -> Flags & GFLG_SELECTED ? FALSE : TRUE,
													TAG_DONE);

													break;

										case MEN_DISABLE:		GT_SetGadgetAttrs(GadgetArray[GAD_DISABLE],PanelWindow,NULL,
														GTCB_Checked,GadgetArray[GAD_DISABLE] -> Flags & GFLG_SELECTED ? FALSE : TRUE,
													TAG_DONE);

													break;

										case MEN_CR:		if(Config -> SendCR == CR_ASCRLF)
														Value = CR_IGNORE;
													else
														Value = Config -> SendCR + 1;

													GT_SetGadgetAttrs(GadgetArray[GAD_CR],PanelWindow,NULL,
														GTCY_Active,Value,
													TAG_DONE);

													Class = IDCMP_GADGETUP;
													Gadget = GadgetArray[GAD_CR];
													Code = Value;

													goto GadCheck;

										case MEN_LF:		if(Config -> SendLF == LF_ASLFCR)
														Value = LF_IGNORE;
													else
														Value = Config -> SendLF + 1;

													GT_SetGadgetAttrs(GadgetArray[GAD_LF],PanelWindow,NULL,
														GTCY_Active,Value,
													TAG_DONE);

													Class = IDCMP_GADGETUP;
													Gadget = GadgetArray[GAD_LF];
													Code = Value;

													goto GadCheck;

										case MEN_COLOUR:	if(Config -> ColourMode == COLOUR_MONO)
														Value = COLOUR_AMIGA;
													else
														Value = Config -> ColourMode + 1;

													GT_SetGadgetAttrs(GadgetArray[GAD_COLOUR],PanelWindow,NULL,
														GTCY_Active,Value,
													TAG_DONE);

													Class = IDCMP_GADGETUP;
													Gadget = GadgetArray[GAD_COLOUR];
													Code = Value;

													goto GadCheck;

										case MEN_EMULATIONCTRL:	if(Config -> Emulation == EMULATION_TTY)
														Value = EMULATION_ANSIVT100;
													else
														Value = Config -> Emulation + 1;

													GT_SetGadgetAttrs(GadgetArray[GAD_EMULATION],PanelWindow,NULL,
														GTCY_Active,Value,
													TAG_DONE);

													Class = IDCMP_GADGETUP;
													Gadget = GadgetArray[GAD_EMULATION];
													Code = Value;

													goto GadCheck;

										case MEN_FONT:		if(Config -> Font == FONT_IBM)
														Value = FONT_TOPAZ;
													else
														Value = FONT_IBM;

													GT_SetGadgetAttrs(GadgetArray[GAD_FONT],PanelWindow,NULL,
														GTCY_Active,Value,
													TAG_DONE);

													Class = IDCMP_GADGETUP;
													Gadget = GadgetArray[GAD_FONT];
													Code = Value;

													goto GadCheck;

										case MEN_USE:		Class = IDCMP_GADGETUP;
													Gadget = GadgetArray[GAD_USE];
													break;

										case MEN_CANCEL:	Class = IDCMP_GADGETUP;
													Gadget = GadgetArray[GAD_CANCEL];
													break;

										default:		break;
									}

									Code = MenuItem -> NextSelect;
								}
							}

							if(Class == IDCMP_CLOSEWINDOW)
								Terminated = TRUE;

GadCheck:						if(Class == IDCMP_GADGETUP)
							{
								switch(Gadget -> GadgetID)
								{
									case GAD_CR:		Config -> SendCR = Code;
												break;

									case GAD_LF:		Config -> SendLF = Code;
												break;

									case GAD_COLOUR:	Config -> ColourMode = Code;

												if(Code > COLOUR_AMIGA && (Config -> Emulation == EMULATION_ATOMIC || Limited))
												{
													GT_SetGadgetAttrs(GadgetArray[GAD_COLOUR],PanelWindow,NULL,
														GTCY_Active,COLOUR_MONO,
													TAG_DONE);

													Config -> ColourMode = COLOUR_MONO;
												}

												break;

									case GAD_EMULATION:	Config -> Emulation = Code;

												if(Code == EMULATION_ATOMIC && Config -> ColourMode != COLOUR_AMIGA && Config -> ColourMode != COLOUR_MONO)
												{
													GT_SetGadgetAttrs(GadgetArray[GAD_COLOUR],PanelWindow,NULL,
														GTCY_Active,COLOUR_MONO,
													TAG_DONE);

													Config -> ColourMode = COLOUR_MONO;
												}

												break;

									case GAD_FONT:		Config -> Font = Code;
												break;

									case GAD_USE:		Terminated = TRUE;

												Config -> CaptureFilter		= GadgetArray[GAD_FILTER] -> Flags & GFLG_SELECTED;
												Config -> DestructiveBackspace	= GadgetArray[GAD_DESTRBS] -> Flags & GFLG_SELECTED;
												Config -> AudibleBell		= GadgetArray[GAD_AUDBEL] -> Flags & GFLG_SELECTED;
												Config -> VisibleBell		= GadgetArray[GAD_VISBEL] -> Flags & GFLG_SELECTED;
												Config -> EightyColumns		= GadgetArray[GAD_FORCE] -> Flags & GFLG_SELECTED;
												Config -> DisableBlinking	= GadgetArray[GAD_DISABLE] -> Flags & GFLG_SELECTED;

												switch(Config -> ColourMode)
												{
													case COLOUR_EIGHT:	CopyMem(&ANSIColours[0],&Config -> Colours[0],16 * sizeof(UWORD));
																break;

													case COLOUR_SIXTEEN:	CopyMem(&EGAColours[0],&Config -> Colours[0],16 * sizeof(UWORD));
																break;

													case COLOUR_AMIGA:	CopyMem(&DefaultColours[0],&Config -> Colours[0],16 * sizeof(UWORD));
																break;

													case COLOUR_MONO:		CopyMem(&AtomicColours[0],&Config -> Colours[0],16 * sizeof(UWORD));
																break;
												}

												break;

									case GAD_CANCEL:	Terminated = TRUE;

												CopyMem(&PrivateConfig,Config,sizeof(struct Configuration));

												break;

									default:		break;
								}
							}
						}
					}

					PanelWindow -> Flags |= WFLG_RMBTRAP;

					ClearMenuStrip(PanelWindow);

					RemoveGList(PanelWindow,GadgetList,(UWORD)-1);

					PopWindow();

					CloseWindow(PanelWindow);
				}
			}

			FreeMenus(PanelMenu);
		}

		FreeGadgets(GadgetList);
	}

	if(Config -> EightyColumns)
	{
		if(Config -> FontScale == SCALE_HALF)
			LastColumn = 131;
		else
		{
			LastColumn	= 79;
			LastLine	= 23;

			BackupRender();

			SetAPen(RPort,0);
			RectFill(RPort,0,(LastLine + 1) * 8,Window -> Width - 1,Window -> Height - 1);

			BackupRender();

			if(CursorY > LastLine)
			{
				CursorY = LastLine;

				SetCursor();
			}
		}
	}
	else
	{
		LastColumn	= (Window -> Width >> 3) - 1;
		LastLine	= (Window -> Height >> 3) - 1;

		if(!UseRegion)
			Bottom = LastLine;
	}

	if(Config -> DisableBlinking)
		LoadRGB4(VPort,&Config -> Colours[0],16);

	if(PrivateConfig . Font != Config -> Font || PrivateConfig . ColourMode != Config -> ColourMode)
		return(TRUE);
	else
		return(FALSE);
}
